package com.company.apachesparkexample.listener;

import org.apache.spark.sql.Dataset;
import org.apache.spark.sql.Row;
import org.apache.spark.sql.SparkSession;
import org.springframework.boot.context.event.ApplicationStartedEvent;
import org.springframework.context.event.ContextRefreshedEvent;
import org.springframework.stereotype.Component;
import org.springframework.context.event.EventListener;

@Component("spark_AppLifecycleEventListener")
public class AppLifecycleEventListener {

    @EventListener
    public void onApplicationStarted(final ApplicationStartedEvent event) {
        SparkSession spark = SparkSession.builder()
                .appName("SparkFilterExample")
                .master("local[2]")  // Use local mode with 2 cores for testing
                .getOrCreate();

        // Read the CSV file into a DataFrame
        Dataset<Row> df = spark.read().csv("file.csv")
                .toDF("id", "value1", "value2");  // Assign column names

        // Apply a filter to select rows where "value1" is greater than 15
        Dataset<Row> filteredDF = df.filter("value1 > 15");

        // Show the filtered DataFrame
        filteredDF.show();
        spark.stop();
    }
}